//////////////////////////////////////////////////////////////////////
// Created by Actel CoreConsole - Fri Jan 25 14:01:23 2008
//////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps

module testbench;

parameter SYSCLK_PERIOD = 100; // 10MHz

reg SYSCLK;
reg NSYSRESET;

initial
begin
    SYSCLK = 1'b0;
    NSYSRESET = 1'b0;

    // Release system reset
    #(SYSCLK_PERIOD * 4)
        NSYSRESET = 1'b1;

    #(SYSCLK_PERIOD * 100000);

    $stop;
end

// SYSCLK signal
always @(SYSCLK)
    #(SYSCLK_PERIOD / 2)
    SYSCLK <= !SYSCLK;

// Instantiate module to test
ccTop ccTop_0(
    // Inputs
    .DDGDON_DDGDON0({1{1'b0}}),
    .DDGDON_DDGDON1({1{1'b0}}),
    .DDGDON_DDGDON2({1{1'b0}}),
    .DDGDON_DDGDON3({1{1'b0}}),
    .DDGDON_DDGDON4({1{1'b0}}),
    .DDGDON_DDGDON5({1{1'b0}}),
    .DDGDON_DDGDON6({1{1'b0}}),
    .DDGDON_DDGDON7({1{1'b0}}),
    .DDGDON_DDGDON8({1{1'b0}}),
    .DDGDON_DDGDON9({1{1'b0}}),
    .NSYSRESET(NSYSRESET),
    .RTC_RTCCLK({1{1'b0}}),
    .RX({1{1'b0}}),
    .RemapDefault({1{1'b0}}),
    .SYSCLK(SYSCLK),
    .UJTAG_UJTAG_TCK({1{1'b0}}),
    .UJTAG_UJTAG_TDI({1{1'b0}}),
    .UJTAG_UJTAG_TMS({1{1'b0}}),
    .UJTAG_UJTAG_TRSTB({1{1'b0}}),
    .analog_signals_AC0({1{1'b0}}),
    .analog_signals_AC1({1{1'b0}}),
    .analog_signals_AC2({1{1'b0}}),
    .analog_signals_AC3({1{1'b0}}),
    .analog_signals_AC4({1{1'b0}}),
    .analog_signals_AC5({1{1'b0}}),
    .analog_signals_AC6({1{1'b0}}),
    .analog_signals_AC7({1{1'b0}}),
    .analog_signals_AC8({1{1'b0}}),
    .analog_signals_AC9({1{1'b0}}),
    .analog_signals_AT0({1{1'b0}}),
    .analog_signals_AT1({1{1'b0}}),
    .analog_signals_AT2({1{1'b0}}),
    .analog_signals_AT3({1{1'b0}}),
    .analog_signals_AT4({1{1'b0}}),
    .analog_signals_AT5({1{1'b0}}),
    .analog_signals_AT6({1{1'b0}}),
    .analog_signals_AT7({1{1'b0}}),
    .analog_signals_AT8({1{1'b0}}),
    .analog_signals_AT9({1{1'b0}}),
    .analog_signals_ATRETURN0({1{1'b0}}),
    .analog_signals_ATRETURN1({1{1'b0}}),
    .analog_signals_ATRETURN2({1{1'b0}}),
    .analog_signals_ATRETURN3({1{1'b0}}),
    .analog_signals_ATRETURN4({1{1'b0}}),
    .analog_signals_AV0({1{1'b0}}),
    .analog_signals_AV1({1{1'b0}}),
    .analog_signals_AV2({1{1'b0}}),
    .analog_signals_AV3({1{1'b0}}),
    .analog_signals_AV4({1{1'b0}}),
    .analog_signals_AV5({1{1'b0}}),
    .analog_signals_AV6({1{1'b0}}),
    .analog_signals_AV7({1{1'b0}}),
    .analog_signals_AV8({1{1'b0}}),
    .analog_signals_AV9({1{1'b0}}),
    .analog_signals_GNDREF({1{1'b0}}),
    .dataIn({32{1'b0}}),
    .dataIn_01({15{1'b0}}),
    // Outputs
    .DACOUT_DACOUT0(),
    .DACOUT_DACOUT1(),
    .DACOUT_DACOUT2(),
    .DACOUT_DACOUT3(),
    .DACOUT_DACOUT4(),
    .DACOUT_DACOUT5(),
    .DACOUT_DACOUT6(),
    .DACOUT_DACOUT7(),
    .DACOUT_DACOUT8(),
    .DACOUT_DACOUT9(),
    .DATOUT_DATOUT0(),
    .DATOUT_DATOUT1(),
    .DATOUT_DATOUT2(),
    .DATOUT_DATOUT3(),
    .DATOUT_DATOUT4(),
    .DATOUT_DATOUT5(),
    .DATOUT_DATOUT6(),
    .DATOUT_DATOUT7(),
    .DATOUT_DATOUT8(),
    .DATOUT_DATOUT9(),
    .DAVOUT_DAVOUT0(),
    .DAVOUT_DAVOUT1(),
    .DAVOUT_DAVOUT2(),
    .DAVOUT_DAVOUT3(),
    .DAVOUT_DAVOUT4(),
    .DAVOUT_DAVOUT5(),
    .DAVOUT_DAVOUT6(),
    .DAVOUT_DAVOUT7(),
    .DAVOUT_DAVOUT8(),
    .DAVOUT_DAVOUT9(),
    .ExternalMemoryInterface_FlashCSN(),
    .ExternalMemoryInterface_FlashOEnN(),
    .ExternalMemoryInterface_FlashWEnN(),
    .ExternalMemoryInterface_MemAddr(),
    .ExternalMemoryInterface_MemReadN(),
    .ExternalMemoryInterface_MemWriteN(),
    .ExternalMemoryInterface_SramByteN(),
    .ExternalMemoryInterface_SramCSN(),
    .ExternalMemoryInterface_SramClk(),
    .ExternalMemoryInterface_SramOEnN(),
    .ExternalMemoryInterface_SramWEnN(),
    .FIQ(),
    .IRQ(),
    .PWM(),
    .RTC_RTCMATCH(),
    .RTC_RTCPSMMATCH(),
    .RTC_RTCXTLMODE0(),
    .RTC_RTCXTLMODE1(),
    .RTC_RTCXTLSEL(),
    .TX(),
    .UJTAG_UJTAG_TDO(),
    .analog_signals_AG0(),
    .analog_signals_AG1(),
    .analog_signals_AG2(),
    .analog_signals_AG3(),
    .analog_signals_AG4(),
    .analog_signals_AG5(),
    .analog_signals_AG6(),
    .analog_signals_AG7(),
    .analog_signals_AG8(),
    .analog_signals_AG9(),
    .dataOut(),
    .dataOut_01(),
    // Inouts
    .ExternalMemoryInterface_MemData(),
    .analog_signals_VAREF()
);

endmodule

