`timescale 1ns/10ps
module
CoreAhbNvm_Ol0
(
HCLK
,
HRESETn
,
HWRITE
,
HSIZE
,
HTRANS
,
HREADYIN
,
HSEL
,
HADDR
,
HRESP
,
HREADY
,
CoreAhbNvm_II0
,
CoreAhbNvm_OO0
,
CoreAhbNvm_IO0
,
CoreAhbNvm_lO0
,
CoreAhbNvm_lI0
,
CoreAhbNvm_OI0
)
;
input
HCLK
;
input
HRESETn
;
input
HWRITE
;
input
[
2
:
0
]
HSIZE
;
input
[
1
:
0
]
HTRANS
;
input
HREADYIN
;
input
HSEL
;
input
[
19
:
0
]
HADDR
;
output
[
1
:
0
]
HRESP
;
wire
[
1
:
0
]
HRESP
;
output
HREADY
;
wire
HREADY
;
input
CoreAhbNvm_II0
;
output
CoreAhbNvm_OO0
;
wire
CoreAhbNvm_OO0
;
output
CoreAhbNvm_IO0
;
wire
CoreAhbNvm_IO0
;
output
CoreAhbNvm_lO0
;
wire
CoreAhbNvm_lO0
;
output
[
2
:
0
]
CoreAhbNvm_lI0
;
wire
[
2
:
0
]
CoreAhbNvm_lI0
;
output
[
19
:
0
]
CoreAhbNvm_OI0
;
wire
[
19
:
0
]
CoreAhbNvm_OI0
;
`define CoreAhbNvm_I00  \
2 \
'b \
00
`define CoreAhbNvm_l00  \
2 \
'b \
01
`define CoreAhbNvm_O10  \
2 \
'b \
10
`define CoreAhbNvm_I10  \
2 \
'b \
11
`define CoreAhbNvm_l10  \
2 \
'b \
00
`define CoreAhbNvm_OO1  \
2 \
'b \
01
`define CoreAhbNvm_IO1  \
2 \
'b \
10
`define CoreAhbNvm_lO1  \
2 \
'b \
11
reg
[
19
:
0
]
CoreAhbNvm_OI1
;
reg
[
2
:
0
]
CoreAhbNvm_II1
;
reg
CoreAhbNvm_lI1
;
reg
CoreAhbNvm_Ol1
;
wire
CoreAhbNvm_Il1
;
assign
HRESP
=
`CoreAhbNvm_l10
;
always
@
(
posedge
HCLK
)
begin
if
(
HREADY
&&
HREADYIN
)
begin
CoreAhbNvm_OI1
<=
HADDR
[
19
:
0
]
;
CoreAhbNvm_lI1
<=
HWRITE
;
CoreAhbNvm_II1
<=
HSIZE
;
end
else
begin
CoreAhbNvm_OI1
<=
CoreAhbNvm_OI1
;
CoreAhbNvm_lI1
<=
CoreAhbNvm_lI1
;
CoreAhbNvm_II1
<=
CoreAhbNvm_lI0
;
end
end
assign
CoreAhbNvm_OI0
=
(
CoreAhbNvm_Ol1
&&
!
CoreAhbNvm_II0
)
?
CoreAhbNvm_OI1
:
HADDR
;
assign
CoreAhbNvm_lO0
=
(
CoreAhbNvm_Ol1
&&
!
CoreAhbNvm_II0
)
?
CoreAhbNvm_lI1
:
HWRITE
;
assign
CoreAhbNvm_lI0
=
(
CoreAhbNvm_Ol1
&&
!
CoreAhbNvm_II0
)
?
CoreAhbNvm_II1
:
HSIZE
;
assign
CoreAhbNvm_IO0
=
HREADY
&&
HREADYIN
&&
HSEL
&&
(
(
HTRANS
==
`CoreAhbNvm_O10
)
||
(
HTRANS
==
`CoreAhbNvm_I10
)
)
;
always
@
(
posedge
HCLK
or
negedge
HRESETn
)
begin
if
(
!
HRESETn
)
CoreAhbNvm_Ol1
<=
1
'b
0
;
else
if
(
CoreAhbNvm_Il1
)
CoreAhbNvm_Ol1
<=
CoreAhbNvm_IO0
;
else
if
(
CoreAhbNvm_II0
)
CoreAhbNvm_Ol1
<=
1
'b
0
;
else
CoreAhbNvm_Ol1
<=
CoreAhbNvm_Ol1
;
end
assign
CoreAhbNvm_OO0
=
CoreAhbNvm_IO0
||
CoreAhbNvm_Ol1
;
assign
CoreAhbNvm_Il1
=
(
CoreAhbNvm_IO0
&&
!
CoreAhbNvm_Ol1
)
||
(
CoreAhbNvm_IO0
&&
CoreAhbNvm_Ol1
&&
CoreAhbNvm_II0
)
;
assign
HREADY
=
(
(
!
CoreAhbNvm_Ol1
)
||
CoreAhbNvm_II0
)
;
endmodule
