`timescale 1ns/1ps
module
CoreGPIO
(
PCLK
,
PRESETn
,
PENABLE
,
PSEL
,
PADDR
,
PWRITE
,
PWDATA
,
dataIn
,
PRDATA
,
dataOut
)
;
parameter
NUM_INPUTS
=
32
;
parameter
NUM_OUTPUTS
=
32
;
input
PCLK
;
input
PRESETn
;
input
PENABLE
;
input
PSEL
;
input
[
5
:
2
]
PADDR
;
input
PWRITE
;
input
[
NUM_OUTPUTS
-
1
:
0
]
PWDATA
;
input
[
NUM_INPUTS
-
1
:
0
]
dataIn
;
output
[
NUM_INPUTS
-
1
:
0
]
PRDATA
;
output
[
NUM_OUTPUTS
-
1
:
0
]
dataOut
;
wire
PCLK
;
wire
PRESETn
;
wire
PENABLE
;
wire
PSEL
;
wire
[
5
:
2
]
PADDR
;
wire
PWRITE
;
wire
[
NUM_OUTPUTS
-
1
:
0
]
PWDATA
;
reg
[
NUM_INPUTS
-
1
:
0
]
PRDATA
;
reg
[
NUM_OUTPUTS
-
1
:
0
]
dataOut
;
wire
CoreGPIO_O
;
wire
CoreGPIO_I
;
reg
[
NUM_INPUTS
-
1
:
0
]
CoreGPIO_l
;
reg
[
NUM_INPUTS
-
1
:
0
]
CoreGPIO_OI
;
reg
[
NUM_INPUTS
-
1
:
0
]
CoreGPIO_II
;
assign
CoreGPIO_I
=
(
PSEL
&&
PWRITE
&&
!
PENABLE
)
?
1
'b
1
:
1
'b
0
;
always
@
(
posedge
PCLK
or
negedge
PRESETn
)
begin
if
(
!
PRESETn
)
dataOut
<=
0
;
else
if
(
CoreGPIO_I
)
dataOut
<=
PWDATA
[
NUM_OUTPUTS
-
1
:
0
]
;
end
assign
CoreGPIO_O
=
(
PSEL
&
!
PWRITE
&
!
PENABLE
)
;
always
@
(
posedge
PCLK
or
negedge
PRESETn
)
begin
if
(
!
PRESETn
)
PRDATA
<=
0
;
else
PRDATA
<=
CoreGPIO_l
;
end
always
@
(
posedge
PCLK
or
negedge
PRESETn
)
begin
if
(
!
PRESETn
)
begin
CoreGPIO_l
<=
0
;
CoreGPIO_OI
<=
0
;
CoreGPIO_II
<=
0
;
end
else
begin
CoreGPIO_OI
<=
dataIn
;
CoreGPIO_II
<=
CoreGPIO_OI
;
if
(
CoreGPIO_O
)
CoreGPIO_l
<=
0
;
else
CoreGPIO_l
<=
(
CoreGPIO_OI
&
CoreGPIO_II
)
;
end
end
endmodule
