`timescale 1ns/1ps
module
CoreRemap
(
PCLK
,
PRESETn
,
PENABLE
,
PSEL
,
PADDR
,
PWRITE
,
PWDATA
,
PRDATA
,
RemapDefault
,
Remap
)
;
input
PCLK
;
input
PRESETn
;
input
PENABLE
;
input
PSEL
;
input
[
5
:
2
]
PADDR
;
input
PWRITE
;
input
[
7
:
0
]
PWDATA
;
output
[
7
:
0
]
PRDATA
;
input
RemapDefault
;
output
Remap
;
`define CoreRemap_O  \
4 \
'b \
0000
wire
PCLK
;
wire
PRESETn
;
wire
PENABLE
;
wire
PSEL
;
wire
[
5
:
2
]
PADDR
;
wire
PWRITE
;
wire
[
7
:
0
]
PWDATA
;
wire
[
7
:
0
]
PRDATA
;
wire
RemapDefault
;
wire
Remap
;
wire
CoreRemap_I
;
reg
CoreRemap_l
;
reg
[
7
:
0
]
CoreRemap_OI
;
wire
CoreRemap_II
;
reg
[
7
:
0
]
CoreRemap_lI
;
assign
CoreRemap_I
=
(
PSEL
&&
PWRITE
&&
!
PENABLE
&&
(
PADDR
==
`CoreRemap_O
)
)
?
1
'b
1
:
1
'b
0
;
always
@
(
posedge
PCLK
or
negedge
PRESETn
)
begin
:
CoreRemap_Ol
if
(
!
PRESETn
)
CoreRemap_l
<=
RemapDefault
;
else
if
(
CoreRemap_I
)
CoreRemap_l
<=
PWDATA
[
0
]
;
end
assign
Remap
=
CoreRemap_l
;
assign
CoreRemap_II
=
(
PSEL
&
!
PWRITE
&
!
PENABLE
)
;
always
@
(
PADDR
or
CoreRemap_II
or
CoreRemap_lI
or
CoreRemap_l
)
begin
:
CoreRemap_Il
if
(
CoreRemap_II
)
case
(
PADDR
)
`CoreRemap_O
:
CoreRemap_OI
=
{
CoreRemap_lI
[
7
:
1
]
,
CoreRemap_l
}
;
default
:
CoreRemap_OI
=
CoreRemap_lI
;
endcase
else
CoreRemap_OI
=
CoreRemap_lI
;
end
always
@
(
posedge
PCLK
or
negedge
PRESETn
)
begin
:
CoreRemap_ll
if
(
!
PRESETn
)
CoreRemap_lI
<=
{
8
{
1
'b
0
}
}
;
else
CoreRemap_lI
<=
CoreRemap_OI
;
end
assign
PRDATA
=
CoreRemap_lI
;
endmodule
