// Copyright 2007 Actel Corporation.  All rights reserved.
// ANY USE OR REDISTRIBUTION IN PART OR IN WHOLE MUST BE HANDLED IN 
// ACCORDANCE WITH THE ACTEL LICENSE AGREEMENT AND MUST BE APPROVED 
// IN ADVANCE IN WRITING.  
// Rev: 3.0  21FEB07  HJ  : v3.0 CoreConsole Release  
`timescale 1ns/1ns
module
COREUART
(
RESET_N
,
CLK
,
WEN
,
OEN
,
CSN
,
DATA_IN
,
RX
,
BAUD_VAL
,
BIT8
,
PARITY_EN
,
ODD_N_EVEN
,
PARITY_ERR
,
OVERFLOW
,
TXRDY
,
RXRDY
,
DATA_OUT
,
TX
)
;
parameter
TX_FIFO
=
0
;
parameter
RX_FIFO
=
0
;
parameter
FAMILY
=
15
;
input
RESET_N
;
input
CLK
;
input
WEN
;
input
OEN
;
input
CSN
;
input
[
7
:
0
]
DATA_IN
;
input
RX
;
input
[
7
:
0
]
BAUD_VAL
;
input
BIT8
;
input
PARITY_EN
;
input
ODD_N_EVEN
;
output
PARITY_ERR
;
output
OVERFLOW
;
output
TXRDY
;
output
RXRDY
;
output
[
7
:
0
]
DATA_OUT
;
output
TX
;
`define CUARTI1II  \
2 \
'b \
00
`define CUARTl1II  \
2 \
'b \
01
`define CUARTOOlI  \
2 \
'b \
10
`define CUARTIOlI  \
2 \
'b \
11
wire
PARITY_ERR
;
wire
OVERFLOW
;
wire
CUARTlOlI
;
wire
TXRDY
;
reg
RXRDY
;
wire
CUARTOIlI
;
wire
CUARTIIlI
;
wire
fifo_write
;
reg
[
7
:
0
]
DATA_OUT
;
wire
TX
;
wire
xmit_pulse
;
wire
baud_clock
;
wire
rst_tx_empty
;
reg
[
7
:
0
]
tx_hold_reg
;
wire
[
7
:
0
]
tx_dout_reg
;
wire
[
7
:
0
]
CUARTlIlI
;
wire
read_rx_byte
;
reg
[
7
:
0
]
CUARTOllI
;
wire
[
7
:
0
]
rx_byte
;
wire
[
7
:
0
]
CUARTIllI
;
wire
CUARTlllI
;
wire
CUARTO0lI
;
reg
CUARTI0lI
;
reg
CUARTl0lI
;
wire
fifo_read_tx
;
wire
CUARTO1lI
;
wire
CUARTI1lI
;
wire
clear_parity
;
wire
clear_parity_en
;
reg
CUARTl1lI
;
reg
CUARTOO0I
;
reg
CUARTIO0I
;
reg
CUARTlO0I
;
reg
CUARTOI0I
;
reg
CUARTII0I
;
reg
CUARTlI0I
;
reg
[
1
:
0
]
CUARTl10
;
reg
[
1
:
0
]
CUARTOl0I
;
always
@
(
posedge
CLK
or
negedge
RESET_N
)
begin
:
CUARTIl0I
if
(
RESET_N
==
1
'b
0
)
begin
tx_hold_reg
<=
{
8
{
1
'b
0
}
}
;
CUARTl0lI
<=
1
'b
1
;
end
else
begin
CUARTl0lI
<=
1
'b
1
;
if
(
CSN
==
1
'b
0
&
WEN
==
1
'b
0
)
begin
tx_hold_reg
<=
DATA_IN
;
CUARTl0lI
<=
1
'b
0
;
end
end
end
assign
rst_tx_empty
=
WEN
==
1
'b
0
&
CSN
==
1
'b
0
?
1
'b
1
:
1
'b
0
;
always
@
(
rx_byte
or
CUARTOllI
or
PARITY_ERR
)
begin
if
(
RX_FIFO
==
1
'b
0
)
begin
DATA_OUT
=
rx_byte
;
end
else
begin
if
(
PARITY_ERR
==
1
'b
1
)
begin
DATA_OUT
=
rx_byte
;
end
else
begin
DATA_OUT
=
CUARTOllI
;
end
end
end
assign
read_rx_byte
=
(
RX_FIFO
==
1
'b
0
)
?
(
(
CSN
==
1
'b
0
&
OEN
==
1
'b
0
)
?
1
'b
1
:
1
'b
0
)
:
!
CUARTI1lI
;
assign
clear_parity
=
(
RX_FIFO
==
1
'b
0
)
?
(
(
CSN
==
1
'b
0
&
OEN
==
1
'b
0
)
?
1
'b
1
:
1
'b
0
)
:
CUARTOO0I
;
assign
CUARTIllI
=
(
PARITY_ERR
==
1
'b
0
)
?
rx_byte
:
8
'b
0
;
always
@
(
CUARTOIlI
or
CUARTlI0I
)
begin
if
(
RX_FIFO
==
1
'b
0
)
begin
RXRDY
=
CUARTOIlI
;
end
else
begin
RXRDY
=
!
CUARTlI0I
;
end
end
always
@
(
posedge
CLK
or
negedge
RESET_N
)
begin
if
(
RESET_N
==
1
'b
0
)
begin
CUARTOO0I
<=
1
'b
0
;
end
else
begin
CUARTl1lI
<=
clear_parity_en
;
CUARTOO0I
<=
CUARTl1lI
;
end
end
always
@
(
posedge
CLK
or
negedge
RESET_N
)
begin
if
(
RESET_N
==
1
'b
0
)
begin
CUARTl10
<=
`CUARTI1II
;
end
else
begin
CUARTl10
<=
CUARTOl0I
;
end
end
always
@
(
CUARTl10
,
CUARTlI0I
,
CUARTO0lI
)
begin
CUARTOl0I
=
CUARTl10
;
CUARTI0lI
=
1
'b
1
;
CUARTOI0I
=
1
'b
0
;
case
(
CUARTl10
)
`CUARTI1II
:
if
(
CUARTlI0I
==
1
'b
1
&&
CUARTO0lI
==
1
'b
0
)
begin
CUARTOl0I
=
`CUARTl1II
;
CUARTI0lI
=
1
'b
0
;
end
`CUARTl1II
:
CUARTOl0I
=
`CUARTOOlI
;
`CUARTOOlI
:
CUARTOl0I
=
`CUARTIOlI
;
`CUARTIOlI
:
begin
CUARTOl0I
=
`CUARTI1II
;
CUARTOI0I
=
1
'b
1
;
end
endcase
end
always
@
(
posedge
CLK
or
negedge
RESET_N
)
begin
if
(
RESET_N
==
1
'b
0
)
begin
CUARTOllI
<=
{
8
{
1
'b
0
}
}
;
end
else
begin
if
(
CUARTOI0I
==
1
'b
1
)
begin
CUARTOllI
<=
CUARTlIlI
;
end
end
end
always
@
(
posedge
CLK
or
negedge
RESET_N
)
begin
if
(
RESET_N
==
1
'b
0
)
begin
CUARTlI0I
<=
1
'b
1
;
end
else
begin
if
(
CUARTOI0I
==
1
'b
1
)
begin
CUARTlI0I
<=
1
'b
0
;
end
else
begin
if
(
CSN
==
1
'b
0
&&
OEN
==
1
'b
0
)
begin
CUARTlI0I
<=
1
'b
1
;
end
end
end
end
assign
OVERFLOW
=
(
RX_FIFO
==
1
'b
0
)
?
CUARTlOlI
:
CUARTI1lI
;
assign
CUARTIIlI
=
PARITY_ERR
?
1
'b
1
:
fifo_write
;
Clock_gen
CUARTll0I
(
.clk
(
CLK
)
,
.reset_n
(
RESET_N
)
,
.CUARTII
(
BAUD_VAL
)
,
.baud_clock
(
baud_clock
)
,
.xmit_pulse
(
xmit_pulse
)
)
;
Tx_async
#
(
.TX_FIFO
(
TX_FIFO
)
)
CUARTO00I
(
.clk
(
CLK
)
,
.xmit_pulse
(
xmit_pulse
)
,
.reset_n
(
RESET_N
)
,
.rst_tx_empty
(
rst_tx_empty
)
,
.tx_hold_reg
(
tx_hold_reg
)
,
.tx_dout_reg
(
tx_dout_reg
)
,
.fifo_empty
(
CUARTlllI
)
,
.fifo_full
(
CUARTO1lI
)
,
.bit8
(
BIT8
)
,
.parity_en
(
PARITY_EN
)
,
.odd_n_even
(
ODD_N_EVEN
)
,
.txrdy
(
TXRDY
)
,
.tx
(
TX
)
,
.fifo_read_tx
(
fifo_read_tx
)
)
;
Rx_async
#
(
.RX_FIFO
(
RX_FIFO
)
)
CUARTI00I
(
.clk
(
CLK
)
,
.baud_clock
(
baud_clock
)
,
.reset_n
(
RESET_N
)
,
.bit8
(
BIT8
)
,
.parity_en
(
PARITY_EN
)
,
.odd_n_even
(
ODD_N_EVEN
)
,
.read_rx_byte
(
read_rx_byte
)
,
.clear_parity
(
clear_parity
)
,
.rx
(
RX
)
,
.overflow
(
CUARTlOlI
)
,
.parity_err
(
PARITY_ERR
)
,
.clear_parity_en
(
clear_parity_en
)
,
.receive_full
(
CUARTOIlI
)
,
.rx_byte
(
rx_byte
)
,
.fifo_write
(
fifo_write
)
)
;
generate
if
(
TX_FIFO
==
1
'b
1
)
begin
CUARTl0
CUARTl00I
(
.DO
(
tx_dout_reg
)
,
.RCLOCK
(
CLK
)
,
.WCLOCK
(
CLK
)
,
.DI
(
DATA_IN
)
,
.WRB
(
CUARTl0lI
)
,
.RDB
(
fifo_read_tx
)
,
.RESET
(
RESET_N
)
,
.FULL
(
CUARTO1lI
)
,
.EMPTY
(
CUARTlllI
)
)
;
end
endgenerate
generate
if
(
RX_FIFO
==
1
'b
1
)
begin
CUARTl0
CUARTO10I
(
.DO
(
CUARTlIlI
)
,
.RCLOCK
(
CLK
)
,
.WCLOCK
(
CLK
)
,
.DI
(
CUARTIllI
)
,
.WRB
(
CUARTIIlI
)
,
.RDB
(
CUARTI0lI
)
,
.RESET
(
RESET_N
)
,
.FULL
(
CUARTI1lI
)
,
.EMPTY
(
CUARTO0lI
)
)
;
end
endgenerate
endmodule
