// Copyright 2007 Actel Corporation.  All rights reserved.
// ANY USE OR REDISTRIBUTION IN PART OR IN WHOLE MUST BE HANDLED IN 
// ACCORDANCE WITH THE ACTEL LICENSE AGREEMENT AND MUST BE APPROVED 
// IN ADVANCE IN WRITING.  
// Rev: 3.1  21FEB07  HJ  : v3.0 CoreConsole Release  
`timescale 1ns/1ns
module
CoreUARTapb
(
PCLK
,
PRESETN
,
PADDR
,
PSEL
,
PENABLE
,
PWRITE
,
PWDATA
,
PRDATA
,
TXRDY
,
RXRDY
,
PARITY_ERR
,
OVERFLOW
,
RX
,
TX
)
;
parameter
FAMILY
=
15
;
parameter
TX_FIFO
=
0
;
parameter
RX_FIFO
=
0
;
parameter
BAUD_VALUE
=
0
;
parameter
FIXEDMODE
=
0
;
parameter
PRG_BIT8
=
0
;
parameter
PRG_PARITY
=
0
;
input
PCLK
;
input
PRESETN
;
input
[
4
:
2
]
PADDR
;
input
PSEL
;
input
PENABLE
;
input
PWRITE
;
input
[
7
:
0
]
PWDATA
;
output
[
7
:
0
]
PRDATA
;
output
TXRDY
;
output
RXRDY
;
input
RX
;
output
TX
;
output
PARITY_ERR
;
output
OVERFLOW
;
`define CUARTI10I  \
3 \
'b \
000
`define CUARTl10I  \
3 \
'b \
001
`define CUARTOO1I  \
3 \
'b \
010
`define CUARTIO1I  \
3 \
'b \
011
`define CUARTlO1I  \
3 \
'b \
100
wire
PCLK
;
wire
PRESETN
;
wire
[
4
:
2
]
PADDR
;
wire
PSEL
;
wire
PENABLE
;
wire
PWRITE
;
wire
[
7
:
0
]
PWDATA
;
wire
[
7
:
0
]
PRDATA
;
wire
TXRDY
;
wire
RXRDY
;
wire
RX
;
wire
TX
;
reg
[
7
:
0
]
CUARTOI1I
;
reg
[
2
:
0
]
CUARTII1I
;
reg
[
7
:
0
]
CUARTlI1I
;
reg
[
7
:
0
]
CUARTOl1I
;
wire
CUARTIl1I
;
wire
[
7
:
0
]
CUARTI1
;
wire
[
7
:
0
]
CUARTl1
;
wire
[
7
:
0
]
CUARTII
;
wire
bit8
;
wire
parity_en
;
wire
odd_n_even
;
wire
CUARTll1I
;
wire
CUARTO01I
;
wire
CUARTI01I
;
wire
OVERFLOW
;
wire
PARITY_ERR
;
wire
[
1
:
0
]
CUARTl01I
;
wire
CUARTO11I
;
wire
CUARTI11I
;
assign
CUARTll1I
=
!
(
PENABLE
&&
PWRITE
&&
(
PADDR
[
4
:
2
]
==
`CUARTI10I
)
)
;
assign
CUARTO01I
=
!
(
PENABLE
&&
!
PWRITE
&&
(
PADDR
[
4
:
2
]
==
`CUARTl10I
)
)
;
assign
CUARTI01I
=
!
PSEL
;
assign
CUARTI1
=
PWDATA
;
assign
CUARTIl1I
=
(
PSEL
&
!
PWRITE
&
!
PENABLE
)
;
always
@
(
PADDR
or
CUARTIl1I
or
CUARTOl1I
or
CUARTl1
or
CUARTOI1I
or
CUARTII1I
or
OVERFLOW
or
PARITY_ERR
or
RXRDY
or
TXRDY
)
begin
:
CUARTl11I
if
(
CUARTIl1I
)
case
(
PADDR
[
4
:
2
]
)
`CUARTI10I
:
CUARTlI1I
=
8
'b
0
;
`CUARTl10I
:
CUARTlI1I
=
CUARTl1
;
`CUARTOO1I
:
CUARTlI1I
=
CUARTOI1I
;
`CUARTIO1I
:
CUARTlI1I
=
{
5
'b
0
,
CUARTII1I
}
;
`CUARTlO1I
:
CUARTlI1I
=
{
4
'b
0
,
OVERFLOW
,
PARITY_ERR
,
RXRDY
,
TXRDY
}
;
default
:
CUARTlI1I
=
CUARTOl1I
;
endcase
else
CUARTlI1I
=
CUARTOl1I
;
end
assign
CUARTl01I
=
PRG_PARITY
;
assign
CUARTO11I
=
(
CUARTl01I
==
(
2
'd
1
||
2
'd
2
)
)
?
1
'b
1
:
1
'b
0
;
assign
CUARTI11I
=
(
CUARTl01I
==
2
'd
1
)
?
1
'b
1
:
1
'b
0
;
always
@
(
posedge
PCLK
or
negedge
PRESETN
)
begin
:
CUARTOOOl
if
(
!
PRESETN
)
CUARTOl1I
<=
8
'b
0
;
else
CUARTOl1I
<=
CUARTlI1I
;
end
assign
PRDATA
=
CUARTOl1I
;
always
@
(
posedge
PCLK
or
negedge
PRESETN
)
begin
:
CUARTIOOl
if
(
!
PRESETN
)
CUARTOI1I
<=
8
'b
0
;
else
if
(
PSEL
&&
PENABLE
&&
PWRITE
&&
(
PADDR
[
4
:
2
]
==
`CUARTOO1I
)
)
CUARTOI1I
<=
PWDATA
;
else
CUARTOI1I
<=
CUARTOI1I
;
end
assign
CUARTII
=
FIXEDMODE
?
BAUD_VALUE
:
CUARTOI1I
;
always
@
(
posedge
PCLK
or
negedge
PRESETN
)
begin
:
CUARTlOOl
if
(
!
PRESETN
)
CUARTII1I
<=
3
'b
0
;
else
if
(
PSEL
&&
PENABLE
&&
PWRITE
&&
(
PADDR
[
4
:
2
]
==
`CUARTIO1I
)
)
CUARTII1I
<=
PWDATA
[
2
:
0
]
;
else
CUARTII1I
<=
CUARTII1I
;
end
assign
bit8
=
FIXEDMODE
?
PRG_BIT8
:
CUARTII1I
[
0
]
;
assign
parity_en
=
FIXEDMODE
?
CUARTO11I
:
CUARTII1I
[
1
]
;
assign
odd_n_even
=
FIXEDMODE
?
CUARTI11I
:
CUARTII1I
[
2
]
;
COREUART
#
(
.TX_FIFO
(
TX_FIFO
)
,
.RX_FIFO
(
RX_FIFO
)
)
CUARTOIOl
(
.RESET_N
(
PRESETN
)
,
.CLK
(
PCLK
)
,
.WEN
(
CUARTll1I
)
,
.OEN
(
CUARTO01I
)
,
.CSN
(
CUARTI01I
)
,
.DATA_IN
(
CUARTI1
)
,
.RX
(
RX
)
,
.BAUD_VAL
(
CUARTII
)
,
.BIT8
(
bit8
)
,
.PARITY_EN
(
parity_en
)
,
.ODD_N_EVEN
(
odd_n_even
)
,
.PARITY_ERR
(
PARITY_ERR
)
,
.OVERFLOW
(
OVERFLOW
)
,
.TXRDY
(
TXRDY
)
,
.RXRDY
(
RXRDY
)
,
.DATA_OUT
(
CUARTl1
)
,
.TX
(
TX
)
)
;
endmodule
