// Copyright 2007 Actel Corporation.  All rights reserved.
// ANY USE OR REDISTRIBUTION IN PART OR IN WHOLE MUST BE HANDLED IN 
// ACCORDANCE WITH THE ACTEL LICENSE AGREEMENT AND MUST BE APPROVED 
// IN ADVANCE IN WRITING.  
// Rev: 3.0  21FEB07  HJ  : v3.0 CoreConsole Release  
`timescale 1ns/1ns
module
Rx_async
(
clk
,
baud_clock
,
reset_n
,
bit8
,
parity_en
,
odd_n_even
,
read_rx_byte
,
clear_parity
,
rx
,
overflow
,
parity_err
,
clear_parity_en
,
receive_full
,
rx_byte
,
fifo_write
)
;
parameter
RX_FIFO
=
0
;
input
clk
;
input
baud_clock
;
input
reset_n
;
input
bit8
;
input
parity_en
;
input
odd_n_even
;
input
read_rx_byte
;
input
clear_parity
;
input
rx
;
output
overflow
;
output
parity_err
;
output
clear_parity_en
;
output
receive_full
;
output
[
7
:
0
]
rx_byte
;
output
fifo_write
;
reg
overflow
;
reg
parity_err
;
reg
fifo_write
;
wire
receive_full
;
reg
[
7
:
0
]
rx_byte
;
reg
[
1
:
0
]
CUARTl10
;
reg
[
3
:
0
]
CUARTOO1
;
reg
CUARTIO1
;
reg
[
8
:
0
]
CUARTlO1
;
reg
CUARTOI1
;
reg
[
3
:
0
]
CUARTII1
;
reg
CUARTlI1
;
reg
[
2
:
0
]
CUARTOl1
;
reg
CUARTIl1
;
reg
clear_parity_en
;
wire
[
1
:
0
]
CUARTll1
;
wire
[
1
:
0
]
CUARTO01
;
wire
[
3
:
0
]
CUARTI01
;
parameter
CUARTl01
=
0
;
parameter
CUARTO11
=
1
;
parameter
CUARTI11
=
2
;
always
@
(
posedge
clk
or
negedge
reset_n
)
begin
:
CUARTl11
if
(
reset_n
==
1
'b
0
)
begin
CUARTOl1
<=
3
'b
000
;
end
else
begin
if
(
baud_clock
==
1
'b
1
)
begin
CUARTOl1
[
1
:
0
]
<=
CUARTOl1
[
2
:
1
]
;
CUARTOl1
[
2
]
<=
rx
;
end
end
end
always
@
(
CUARTOl1
)
begin
case
(
CUARTOl1
)
3
'b
000
:
begin
CUARTIO1
<=
1
'b
0
;
end
3
'b
001
:
begin
CUARTIO1
<=
1
'b
0
;
end
3
'b
010
:
begin
CUARTIO1
<=
1
'b
0
;
end
3
'b
011
:
begin
CUARTIO1
<=
1
'b
1
;
end
3
'b
100
:
begin
CUARTIO1
<=
1
'b
0
;
end
3
'b
101
:
begin
CUARTIO1
<=
1
'b
1
;
end
3
'b
110
:
begin
CUARTIO1
<=
1
'b
1
;
end
default
:
begin
CUARTIO1
<=
1
'b
1
;
end
endcase
end
always
@
(
posedge
clk
or
negedge
reset_n
)
begin
:
CUARTOOOI
if
(
reset_n
==
1
'b
0
)
begin
CUARTOO1
<=
4
'b
0000
;
end
else
begin
if
(
baud_clock
==
1
'b
1
)
begin
if
(
CUARTl10
==
CUARTl01
&
(
CUARTIO1
==
1
'b
1
|
CUARTOO1
==
4
'b
1000
)
)
begin
CUARTOO1
<=
4
'b
0000
;
end
else
begin
CUARTOO1
<=
CUARTOO1
+
1
'b
1
;
end
end
end
end
always
@
(
posedge
clk
or
negedge
reset_n
)
begin
:
CUARTIOOI
if
(
reset_n
==
1
'b
0
)
begin
overflow
<=
1
'b
0
;
end
else
begin
if
(
baud_clock
==
1
'b
1
)
begin
if
(
CUARTIl1
==
1
'b
1
)
begin
overflow
<=
1
'b
1
;
end
end
if
(
read_rx_byte
==
1
'b
1
)
begin
overflow
<=
1
'b
0
;
end
end
end
assign
CUARTI01
=
bit8
==
1
'b
0
&
parity_en
==
1
'b
0
?
4
'b
0111
:
bit8
==
1
'b
0
&
parity_en
==
1
'b
1
?
4
'b
1000
:
bit8
==
1
'b
1
&
parity_en
==
1
'b
0
?
4
'b
1000
:
4
'b
1001
;
always
@
(
posedge
clk
or
negedge
reset_n
)
begin
:
CUARTlOOI
if
(
reset_n
==
1
'b
0
)
begin
CUARTl10
<=
CUARTl01
;
rx_byte
<=
8
'b
00000000
;
CUARTIl1
<=
1
'b
0
;
end
else
begin
if
(
baud_clock
==
1
'b
1
)
begin
CUARTIl1
<=
1
'b
0
;
case
(
CUARTl10
)
CUARTl01
:
begin
if
(
CUARTOO1
==
4
'b
1000
)
begin
CUARTl10
<=
CUARTO11
;
end
else
begin
CUARTl10
<=
CUARTl01
;
end
end
CUARTO11
:
begin
if
(
CUARTII1
==
CUARTI01
)
begin
CUARTl10
<=
CUARTI11
;
CUARTIl1
<=
CUARTlI1
;
if
(
CUARTlI1
==
1
'b
0
)
begin
rx_byte
<=
{
(
bit8
&
CUARTlO1
[
7
]
)
,
CUARTlO1
[
6
:
0
]
}
;
end
end
else
begin
CUARTl10
<=
CUARTO11
;
end
end
CUARTI11
:
begin
if
(
CUARTOO1
==
4
'b
1111
)
begin
CUARTl10
<=
CUARTl01
;
end
else
begin
CUARTl10
<=
CUARTI11
;
end
end
default
:
begin
CUARTl10
<=
CUARTl01
;
end
endcase
end
end
end
assign
CUARTll1
=
{
bit8
,
parity_en
}
;
always
@
(
posedge
clk
or
negedge
reset_n
)
begin
:
CUARTOIOI
if
(
reset_n
==
1
'b
0
)
begin
CUARTlO1
[
8
:
0
]
<=
9
'b
000000000
;
CUARTII1
<=
4
'b
0000
;
end
else
begin
if
(
baud_clock
==
1
'b
1
)
begin
if
(
CUARTl10
==
CUARTl01
)
begin
CUARTlO1
[
8
:
0
]
<=
9
'b
000000000
;
CUARTII1
<=
4
'b
0000
;
end
else
if
(
CUARTOO1
==
4
'b
1111
)
begin
CUARTII1
<=
CUARTII1
+
1
'b
1
;
case
(
CUARTll1
)
2
'b
00
:
begin
CUARTlO1
[
5
:
0
]
<=
CUARTlO1
[
6
:
1
]
;
CUARTlO1
[
6
]
<=
CUARTIO1
;
end
2
'b
11
:
begin
CUARTlO1
[
7
:
0
]
<=
CUARTlO1
[
8
:
1
]
;
CUARTlO1
[
8
]
<=
CUARTIO1
;
end
default
:
begin
CUARTlO1
[
6
:
0
]
<=
CUARTlO1
[
7
:
1
]
;
CUARTlO1
[
7
]
<=
CUARTIO1
;
end
endcase
end
end
end
end
always
@
(
posedge
clk
or
negedge
reset_n
)
begin
:
CUARTIIOI
if
(
reset_n
==
1
'b
0
)
begin
CUARTOI1
<=
1
'b
0
;
end
else
begin
if
(
baud_clock
==
1
'b
1
)
begin
if
(
CUARTOO1
==
4
'b
1111
&
parity_en
==
1
'b
1
)
begin
CUARTOI1
<=
CUARTOI1
^
CUARTIO1
;
end
if
(
CUARTl10
==
CUARTI11
)
begin
CUARTOI1
<=
1
'b
0
;
end
end
end
end
assign
CUARTO01
=
{
bit8
,
odd_n_even
}
;
always
@
(
posedge
clk
or
negedge
reset_n
)
begin
:
CUARTlIOI
if
(
reset_n
==
1
'b
0
)
begin
parity_err
<=
1
'b
0
;
end
else
begin
if
(
baud_clock
==
1
'b
1
&
parity_en
==
1
'b
1
&
CUARTOO1
==
4
'b
1111
)
begin
case
(
CUARTO01
)
2
'b
00
:
begin
if
(
CUARTII1
==
4
'b
0111
)
begin
parity_err
<=
CUARTOI1
^
CUARTIO1
;
end
end
2
'b
01
:
begin
if
(
CUARTII1
==
4
'b
0111
)
begin
parity_err
<=
~
(
CUARTOI1
^
CUARTIO1
)
;
end
end
2
'b
10
:
begin
if
(
CUARTII1
==
4
'b
1000
)
begin
parity_err
<=
CUARTOI1
^
CUARTIO1
;
end
end
2
'b
11
:
begin
if
(
CUARTII1
==
4
'b
1000
)
begin
parity_err
<=
~
(
CUARTOI1
^
CUARTIO1
)
;
end
end
default
:
begin
parity_err
<=
1
'b
0
;
end
endcase
end
if
(
clear_parity
==
1
'b
1
)
begin
parity_err
<=
1
'b
0
;
end
end
end
always
@
(
posedge
clk
or
negedge
reset_n
)
begin
:
CUARTOlOI
if
(
reset_n
==
1
'b
0
)
begin
CUARTlI1
<=
1
'b
0
;
fifo_write
<=
1
'b
1
;
clear_parity_en
<=
1
'b
0
;
end
else
begin
fifo_write
<=
1
'b
1
;
clear_parity_en
<=
1
'b
0
;
if
(
baud_clock
==
1
'b
1
)
begin
if
(
bit8
==
1
'b
1
)
begin
if
(
parity_en
==
1
'b
1
)
begin
if
(
CUARTII1
==
4
'b
1001
&
CUARTl10
==
CUARTO11
)
begin
fifo_write
<=
1
'b
0
;
clear_parity_en
<=
1
'b
1
;
if
(
RX_FIFO
==
1
'b
0
)
begin
CUARTlI1
<=
1
'b
1
;
end
end
end
else
begin
if
(
CUARTII1
==
4
'b
1000
&
CUARTl10
==
CUARTO11
)
begin
fifo_write
<=
1
'b
0
;
clear_parity_en
<=
1
'b
1
;
if
(
RX_FIFO
==
1
'b
0
)
begin
CUARTlI1
<=
1
'b
1
;
end
end
end
end
else
begin
if
(
parity_en
==
1
'b
1
)
begin
if
(
CUARTII1
==
4
'b
1000
&
CUARTl10
==
CUARTO11
)
begin
fifo_write
<=
1
'b
0
;
clear_parity_en
<=
1
'b
1
;
if
(
RX_FIFO
==
1
'b
0
)
begin
CUARTlI1
<=
1
'b
1
;
end
end
end
else
begin
if
(
CUARTII1
==
4
'b
0111
&
CUARTl10
==
CUARTO11
)
begin
fifo_write
<=
1
'b
0
;
clear_parity_en
<=
1
'b
1
;
if
(
RX_FIFO
==
1
'b
0
)
begin
CUARTlI1
<=
1
'b
1
;
end
end
end
end
end
if
(
read_rx_byte
==
1
'b
1
)
begin
CUARTlI1
<=
1
'b
0
;
end
end
end
assign
receive_full
=
CUARTlI1
;
endmodule
