// Copyright 2007 Actel Corporation.  All rights reserved.
// ANY USE OR REDISTRIBUTION IN PART OR IN WHOLE MUST BE HANDLED IN 
// ACCORDANCE WITH THE ACTEL LICENSE AGREEMENT AND MUST BE APPROVED 
// IN ADVANCE IN WRITING.  
// Rev: 3.0  21FEB07  HJ  : v3.0 CoreConsole Release  
`timescale 1ns/1ns
module
Tx_async
(
clk
,
xmit_pulse
,
reset_n
,
rst_tx_empty
,
tx_hold_reg
,
tx_dout_reg
,
fifo_empty
,
fifo_full
,
bit8
,
parity_en
,
odd_n_even
,
txrdy
,
tx
,
fifo_read_tx
)
;
parameter
TX_FIFO
=
0
;
input
clk
;
input
xmit_pulse
;
input
reset_n
;
input
rst_tx_empty
;
input
[
7
:
0
]
tx_hold_reg
;
input
[
7
:
0
]
tx_dout_reg
;
input
fifo_empty
;
input
fifo_full
;
input
bit8
;
input
parity_en
;
input
odd_n_even
;
output
txrdy
;
wire
txrdy
;
output
tx
;
output
fifo_read_tx
;
reg
tx
;
parameter
CUARTIlOI
=
0
;
parameter
CUARTllOI
=
1
;
parameter
CUARTO0OI
=
2
;
parameter
CUARTI0OI
=
3
;
parameter
CUARTl0OI
=
4
;
parameter
CUARTO1OI
=
5
;
parameter
CUARTI1OI
=
6
;
integer
CUARTl1OI
;
reg
CUARTOOII
;
reg
[
7
:
0
]
CUARTIOII
;
reg
[
3
:
0
]
CUARTlOII
;
reg
CUARTOIII
;
reg
fifo_read_tx
;
reg
CUARTIIII
;
reg
CUARTlIII
;
wire
CUARTOlII
;
wire
fifo_write
;
always
@
(
posedge
clk
or
negedge
reset_n
)
begin
:
CUARTIlII
if
(
!
reset_n
)
begin
CUARTOOII
<=
1
'b
1
;
end
else
begin
if
(
TX_FIFO
==
1
'b
0
)
begin
if
(
xmit_pulse
)
begin
if
(
CUARTl1OI
==
CUARTllOI
)
begin
CUARTOOII
<=
1
'b
1
;
end
end
if
(
rst_tx_empty
)
begin
CUARTOOII
<=
1
'b
0
;
end
end
else
begin
CUARTOOII
<=
!
fifo_full
;
end
end
end
always
@
(
posedge
clk
or
negedge
reset_n
)
begin
:
CUARTllII
if
(
!
reset_n
)
begin
CUARTl1OI
<=
CUARTIlOI
;
CUARTIOII
<=
'b
0
;
CUARTIIII
<=
1
'b
1
;
end
else
begin
if
(
xmit_pulse
)
begin
CUARTIIII
<=
1
'b
1
;
case
(
CUARTl1OI
)
CUARTIlOI
:
begin
if
(
TX_FIFO
==
1
'b
0
)
begin
if
(
!
CUARTOOII
)
begin
CUARTl1OI
<=
CUARTllOI
;
end
else
begin
CUARTl1OI
<=
CUARTIlOI
;
end
end
else
begin
if
(
fifo_empty
==
1
'b
0
)
begin
CUARTIIII
<=
1
'b
0
;
CUARTl1OI
<=
CUARTI1OI
;
end
else
begin
CUARTl1OI
<=
CUARTIlOI
;
CUARTIIII
<=
1
'b
1
;
end
end
end
CUARTllOI
:
begin
if
(
TX_FIFO
==
1
'b
0
)
begin
CUARTIOII
<=
tx_hold_reg
;
end
else
begin
CUARTIOII
<=
tx_dout_reg
;
end
CUARTl1OI
<=
CUARTO0OI
;
end
CUARTO0OI
:
begin
CUARTl1OI
<=
CUARTI0OI
;
end
CUARTI0OI
:
begin
if
(
bit8
)
begin
if
(
CUARTlOII
==
4
'b
0111
)
begin
if
(
parity_en
)
begin
CUARTl1OI
<=
CUARTl0OI
;
end
else
begin
CUARTl1OI
<=
CUARTO1OI
;
end
end
else
begin
CUARTl1OI
<=
CUARTI0OI
;
end
end
else
begin
if
(
CUARTlOII
==
4
'b
0110
)
begin
if
(
parity_en
)
begin
CUARTl1OI
<=
CUARTl0OI
;
end
else
begin
CUARTl1OI
<=
CUARTO1OI
;
end
end
else
begin
CUARTl1OI
<=
CUARTI0OI
;
end
end
end
CUARTl0OI
:
begin
CUARTl1OI
<=
CUARTO1OI
;
end
CUARTO1OI
:
begin
CUARTl1OI
<=
CUARTIlOI
;
end
CUARTI1OI
:
begin
CUARTl1OI
<=
CUARTllOI
;
end
default
:
begin
CUARTl1OI
<=
CUARTIlOI
;
end
endcase
end
end
end
always
@
(
posedge
clk
or
negedge
reset_n
)
begin
:
CUARTO0II
if
(
!
reset_n
)
begin
fifo_read_tx
<=
1
'b
1
;
CUARTlIII
<=
1
'b
1
;
end
else
begin
fifo_read_tx
<=
1
'b
1
;
CUARTlIII
<=
CUARTIIII
;
if
(
CUARTOlII
==
1
'b
0
)
begin
fifo_read_tx
<=
1
'b
0
;
end
end
end
assign
CUARTOlII
=
(
!
CUARTlIII
|
CUARTIIII
)
;
always
@
(
posedge
clk
or
negedge
reset_n
)
begin
:
CUARTI0II
if
(
!
reset_n
)
begin
CUARTlOII
<=
4
'b
0000
;
end
else
begin
if
(
xmit_pulse
)
begin
if
(
CUARTl1OI
!=
CUARTI0OI
)
begin
CUARTlOII
<=
4
'b
0000
;
end
else
begin
CUARTlOII
<=
CUARTlOII
+
1
'b
1
;
end
end
end
end
always
@
(
posedge
clk
or
negedge
reset_n
)
begin
:
CUARTl0II
if
(
!
reset_n
)
begin
tx
<=
1
'b
1
;
end
else
begin
if
(
xmit_pulse
)
begin
case
(
CUARTl1OI
)
CUARTIlOI
:
begin
tx
<=
1
'b
1
;
end
CUARTllOI
:
begin
tx
<=
1
'b
1
;
end
CUARTO0OI
:
begin
tx
<=
1
'b
0
;
end
CUARTI0OI
:
begin
tx
<=
CUARTIOII
[
CUARTlOII
]
;
end
CUARTl0OI
:
begin
tx
<=
odd_n_even
^
CUARTOIII
;
end
CUARTO1OI
:
begin
tx
<=
1
'b
1
;
end
default
:
begin
tx
<=
1
'b
1
;
end
endcase
end
end
end
always
@
(
posedge
clk
or
negedge
reset_n
)
begin
:
CUARTO1II
if
(
!
reset_n
)
begin
CUARTOIII
<=
1
'b
0
;
end
else
begin
if
(
xmit_pulse
&
parity_en
)
begin
if
(
CUARTl1OI
==
CUARTI0OI
)
begin
CUARTOIII
<=
CUARTOIII
^
CUARTIOII
[
CUARTlOII
]
;
end
else
begin
CUARTOIII
<=
CUARTOIII
;
end
end
if
(
CUARTl1OI
==
CUARTO1OI
)
begin
CUARTOIII
<=
1
'b
0
;
end
end
end
assign
txrdy
=
CUARTOOII
;
endmodule
