module
corepwm_l0
#
(
parameter
PWM_NUM
=
8
)
(
input
PCLK,
input
PRESET_N,
input
PSEL,
input
PENABLE,
input
PWRITE,
input
[
4
:
0
]
PADDR,
input
[
7
:
0
]
PWDATA,
output
reg
[
7
:
0
]
PRDATA,
input
[
7
:
0
]
corepwm_l,
input
corepwm_O0,
output
reg
[
7
:
0
]
corepwm_I,
output
reg
[
7
:
0
]
corepwm_O,
output
reg
[
PWM_NUM
-
1
:
0
]
corepwm_lI,
output
reg
[
PWM_NUM
*
8
-
1
:
0
]
corepwm_Ol,
output
reg
[
PWM_NUM
*
8
-
1
:
0
]
corepwm_Il,
input
[
PWM_NUM
-
1
:
0
]
corepwm_OI,
output
reg
[
PWM_NUM
-
1
:
0
]
corepwm_II,
output
corepwm_ll
)
;
reg
[
7
:
0
]
corepwm_OlI
;
reg
[
7
:
0
]
corepwm_IlI
;
reg
[
PWM_NUM
-
1
:
0
]
corepwm_llI
;
reg
[
8
*
8
-
1
:
0
]
corepwm_O0I
;
reg
[
8
*
8
-
1
:
0
]
corepwm_I0I
;
reg
[
7
:
0
]
corepwm_l0I
;
always
@
(
negedge
PRESET_N
or
posedge
PCLK
)
begin
if
(
!
PRESET_N
)
begin
corepwm_OlI
<=
8
'h
08
;
corepwm_IlI
<=
8
'h
08
;
corepwm_llI
<=
0
;
corepwm_l0I
<=
0
;
end
else
begin
if
(
(
PSEL
==
1
'b
1
)
&&
(
PWRITE
==
1
'b
1
)
&&
(
PENABLE
==
1
'b
1
)
)
begin
case
(
PADDR
)
5
'h
00
:
corepwm_OlI
<=
PWDATA
;
5
'h
01
:
corepwm_IlI
<=
PWDATA
;
5
'h
02
:
corepwm_llI
<=
PWDATA
;
5
'h
03
:
corepwm_l0I
<=
PWDATA
;
endcase
end
end
end
genvar
corepwm_OII
;
generate
for
(
corepwm_OII
=
0
;
corepwm_OII
<=
(
PWM_NUM
-
1
)
;
corepwm_OII
=
corepwm_OII
+
1
)
begin
:
corepwm_O1I
always
@
(
negedge
PRESET_N
or
posedge
PCLK
)
begin
if
(
!
PRESET_N
)
begin
corepwm_O0I
[
corepwm_OII
*
8
+
(
7
)
:
corepwm_OII
*
8
]
<=
0
;
corepwm_I0I
[
corepwm_OII
*
8
+
(
7
)
:
corepwm_OII
*
8
]
<=
0
;
end
else
begin
if
(
(
PSEL
==
1
'b
1
)
&&
(
PWRITE
==
1
'b
1
)
&&
(
PENABLE
==
1
'b
1
)
)
begin
case
(
PADDR
)
(
5
+
corepwm_OII
*
2
)
:
corepwm_O0I
[
corepwm_OII
*
8
+
(
7
)
:
corepwm_OII
*
8
]
<=
PWDATA
;
(
6
+
corepwm_OII
*
2
)
:
corepwm_I0I
[
corepwm_OII
*
8
+
(
7
)
:
corepwm_OII
*
8
]
<=
PWDATA
;
endcase
end
end
end
end
endgenerate
always
@
*
begin
case
(
PADDR
)
5
'h
00
:
PRDATA
=
corepwm_OlI
;
5
'h
01
:
PRDATA
=
corepwm_IlI
;
5
'h
02
:
PRDATA
=
corepwm_llI
;
5
'h
03
:
PRDATA
=
corepwm_l0I
;
5
'h
04
:
PRDATA
=
corepwm_OI
;
5
'h
05
:
PRDATA
=
corepwm_O0I
[
0
*
8
+
(
7
)
:
0
*
8
]
;
5
'h
06
:
PRDATA
=
corepwm_I0I
[
0
*
8
+
(
7
)
:
0
*
8
]
;
5
'h
07
:
PRDATA
=
corepwm_O0I
[
1
*
8
+
(
7
)
:
1
*
8
]
;
5
'h
08
:
PRDATA
=
corepwm_I0I
[
1
*
8
+
(
7
)
:
1
*
8
]
;
5
'h
09
:
PRDATA
=
corepwm_O0I
[
2
*
8
+
(
7
)
:
2
*
8
]
;
5
'h
0a
:
PRDATA
=
corepwm_I0I
[
2
*
8
+
(
7
)
:
2
*
8
]
;
5
'h
0b
:
PRDATA
=
corepwm_O0I
[
3
*
8
+
(
7
)
:
3
*
8
]
;
5
'h
0c
:
PRDATA
=
corepwm_I0I
[
3
*
8
+
(
7
)
:
3
*
8
]
;
5
'h
0d
:
PRDATA
=
corepwm_O0I
[
4
*
8
+
(
7
)
:
4
*
8
]
;
5
'h
0e
:
PRDATA
=
corepwm_I0I
[
4
*
8
+
(
7
)
:
4
*
8
]
;
5
'h
0f
:
PRDATA
=
corepwm_O0I
[
5
*
8
+
(
7
)
:
5
*
8
]
;
5
'h
10
:
PRDATA
=
corepwm_I0I
[
5
*
8
+
(
7
)
:
5
*
8
]
;
5
'h
11
:
PRDATA
=
corepwm_O0I
[
6
*
8
+
(
7
)
:
6
*
8
]
;
5
'h
12
:
PRDATA
=
corepwm_I0I
[
6
*
8
+
(
7
)
:
6
*
8
]
;
5
'h
13
:
PRDATA
=
corepwm_O0I
[
7
*
8
+
(
7
)
:
7
*
8
]
;
5
'h
14
:
PRDATA
=
corepwm_I0I
[
7
*
8
+
(
7
)
:
7
*
8
]
;
default
:
PRDATA
=
0
;
endcase
end
assign
corepwm_ll
=
(
(
PENABLE
==
1
'b
1
)
&&
(
PADDR
==
5
'h
04
)
)
?
1
'b
1
:
1
'b
0
;
always
@
(
negedge
PRESET_N
or
posedge
PCLK
)
begin
if
(
!
PRESET_N
)
begin
corepwm_O
<=
8
'h
08
;
corepwm_I
<=
8
'h
08
;
corepwm_lI
<=
0
;
corepwm_II
<=
0
;
corepwm_Ol
<=
0
;
corepwm_Il
<=
0
;
end
else
begin
if
(
(
corepwm_l
>=
corepwm_I
)
&&
(
corepwm_O0
)
)
begin
corepwm_O
<=
corepwm_OlI
;
corepwm_I
<=
corepwm_IlI
;
corepwm_lI
<=
corepwm_llI
;
corepwm_II
<=
corepwm_l0I
;
corepwm_Ol
<=
corepwm_O0I
;
corepwm_Il
<=
corepwm_I0I
;
end
end
end
endmodule
