//**********************************************************************
// This code was created by SoC Solutions and is free for use with     *
// Actel products.  For support e-mail support@socsolutions.com.       *
//**********************************************************************

#ifndef __SOC_DEFINES_H
#define __SOC_DEFINES_H	1

#define SYSCLK  22000000

#define DONT_CARE 0

typedef unsigned          uint32;
typedef unsigned short    uint16;
typedef unsigned char     uint8;

#define PUT_UINT32(addr, data)    (*((volatile uint32 *) (addr)) = (data))
#define PUT_UINT16(addr, data)    (*((volatile uint16 *) (addr)) = (data))
#define PUT_UINT8(addr,  data)    (*((volatile uint8  *) (addr)) = (data))

#define GET_UINT32(addr, pData)   (*(pData) = *((volatile uint32 *) (addr)))
#define GET_UINT16(addr, pData)   (*(pData) = *((volatile uint16 *) (addr)))
#define GET_UINT8(addr,  pData)   (*(pData) = *((volatile uint8  *) (addr)))

// verification functions:

#define VER_UINT32(addr, pData, expVal)    GET_UINT32(addr,pData); if (*pData != expVal) {sprintf(str,"Verify error! Expected %x, Got %x", expVal, *pData); uart_puts(UARTA_BASE, str);}
#define VER_UINT16(addr, pData, expVal)    GET_UINT16(addr,pData); if (*pData != expVal) {sprintf(str,"Verify error! Expected %x, Got %x", expVal, *pData); uart_puts(UARTA_BASE, str);}
#define VER_UINT8(addr,  pData, expVal)    GET_UINT8(addr,pData) ; if (*pData != expVal) {sprintf(str,"Verify error! Expected %x, Got %x", expVal, *pData); uart_puts(UARTA_BASE, str);}

#endif
