//**********************************************************************
// This code was created by SoC Solutions and is free for use with     *
// Actel products.  For support e-mail support@socsolutions.com.       *
//**********************************************************************

// SoC Solutions M1AFS board Testbench code - main

#include "socDefs.h"
#include "socTb.h"
#include "SocAddrDec.h"
#include "APB_Interrupt.h"
#include "APB_Analog.h"
#include "externals.h"


//###############################################################
//  	Interrupt handler routines
//###############################################################


void IRQ_Handler(void) 
{
    uint32 isrData;

    // determine source of interrupt:
    GET_UINT32(IRQ_BASE+INTERRUPT_IRQSTATUS_OFFSET, &isrData);
/*
    if (isrData & IRQSerialA_BITMASK)
        uartIsr(UARTA_BASE);

    if (isrData & IRQSerialB_BITMASK)
        uartIsr(UARTB_BASE);

    if (isrData & IRQTimer2_BITMASK)
        timerIsr(TIMER2_BASE);

    if (isrData & IRQTimer1_BITMASK)
        timerIsr(TIMER1_BASE);
*/

    //clear the interrupt in the NVIC
    PUT_UINT32(CORTEXM1_NVEC_IRQ_CLR_PENDING, CORTEXM1_IRQ0);
}

//###############################################################
//	Main program
//###############################################################

struct analog_ch_desc adata[] = 
{
    {AMUX_CH_AV8,       128,    ANALOG_CH_TYPE_VOLTAGE  },
    {AMUX_CH_AT8,       128,    ANALOG_CH_TYPE_TEMP     },
    {AMUX_CH_AT9,       128,    ANALOG_CH_TYPE_TEMP     },
    {AMUX_CH_INT_TEMP,  128,    ANALOG_CH_TYPE_TEMP     },
    {AMUX_CH_AV7,       128,    ANALOG_CH_TYPE_VOLTAGE  },
    {AMUX_CH_AC7,       128,    ANALOG_CH_TYPE_CURRENT  },
    {AMUX_CH_AV9,       128,    ANALOG_CH_TYPE_VOLTAGE  },
    {AMUX_CH_AC9,       128,    ANALOG_CH_TYPE_CURRENT  },
    {AMUX_CH_AV6,       128,    ANALOG_CH_TYPE_VOLTAGE  },
    {AMUX_CH_AC6,       128,    ANALOG_CH_TYPE_CURRENT  },
    {AMUX_CH_NONE,        1,    ANALOG_CH_TYPE_CURRENT  }
};

int main (void)
{
    // Set up the UART
    uart_cfg(UARTA_BASE, 23); //23 gives 57600 @ 22MHz; 12 gives 115200 @ 22MHz

    while(1)
    {
        socMeasAnalogChans(&adata[0]);
    }
}
